#include "mmp_leddemo_objects.h"
#include "mmp_leddemo_resources.h"
#include "built_in.h"


// TFT module connections
sbit TFT_BLED at GPIOF_ODR.B10;
sbit TFT_CS at GPIOF_ODR.B13;
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RD at GPIOF_ODR.B12;
sbit TFT_RS at GPIOF_ODR.B15;
sbit TFT_RST at GPIOF_ODR.B14;
sbit TFT_WR at GPIOF_ODR.B11;
// End TFT module connections


// Global variables
unsigned int Xcoord, Ycoord;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TImage *local_image;
TImage *exec_image;
int image_order;
TCircle *local_circle;
TCircle *exec_circle;
int circle_order;
TBox *local_box;
TBox *exec_box;
int box_order;


void Write_to_Data_Lines(unsigned char _hi, unsigned char _lo) {
  unsigned int temp;
  temp = GPIOE_ODR;
  temp &= 0x00FF;
  GPIOE_ODR = temp | (_hi << 8);
  temp = GPIOG_ODR;
  temp &= 0xFF00;
  GPIOG_ODR = temp | _lo;
}

void Set_Index(unsigned short index) {
  TFT_RS = 0;
  Write_to_Data_Lines(0, index);
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

void Write_Command(unsigned short cmd) {
  TFT_RS = 1;
  Write_to_Data_Lines(0, cmd);
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

void Write_Data(unsigned int _data) {
  TFT_RS = 1;
  Write_to_Data_Lines(Hi(_data), Lo(_data));
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

static void InitializeTouchPanel() {
  TFT_Set_Active(Set_Index, Write_Command, Write_Data);
  TFT_Init_SSD1963(480, 272);


  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                home;
  TBox                   Box1;
  TLabel                 MainLabel;
char MainLabel_Caption[19] = "RGB-LED / CAN demo";

  TButton               bRedOn;
char bRedOn_Caption[7] = "RED on";

  TButton               bRedOff;
char bRedOff_Caption[8] = "RED off";

  TButton               bGreenOn;
char bGreenOn_Caption[9] = "GREEN on";

  TButton               bGreenOff;
char bGreenOff_Caption[10] = "GREEN off";

  TButton               bBlueOn;
char bBlueOn_Caption[8] = "BLUE on";

  TButton               bBlueOff;
char bBlueOff_Caption[9] = "BLUE off";

  TButton               bRedBlink;
char bRedBlink_Caption[10] = "RED blink";

  TButton               bGreenBlink;
char bGreenBlink_Caption[12] = "GREEN blink";

  TButton               bBlueBlink;
char bBlueBlink_Caption[11] = "BLUE blink";

  TLine                  TopLine;
  TCircle                LedRedIndicator;
  TCircle                LedGreenIndicator;
  TCircle                LedBlueIndicator;
  TLabel                 l_ID;
char l_ID_Caption[4] = "ID:";

  TLabel                 l_DLC;
char l_DLC_Caption[5] = "DLC:";

  TLabel                 l_DATA;
char l_DATA_Caption[6] = "DATA:";

  TCircle                CANRXIndicator;
  TLabel                 l_CANRX;
char l_CANRX_Caption[7] = "CAN Rx";

  TBox                   dynamicbox_1;
  TLabel                 rcvdID;
char rcvdID_Caption[3] = "--";

  TLabel                 rcvdDLC;
char rcvdDLC_Caption[3] = "--";

  TLabel                 rcvdDB0;
char rcvdDB0_Caption[3] = "--";

  TLabel                 rcvdDB1;
char rcvdDB1_Caption[3] = "--";

  TLabel                 rcvdDB2;
char rcvdDB2_Caption[3] = "--";

  TLabel                 rcvdDB3;
char rcvdDB3_Caption[3] = "--";

  TLabel                 rcvdDB4;
char rcvdDB4_Caption[3] = "--";

  TLabel                 rcvdDB5;
char rcvdDB5_Caption[3] = "--";

  TLabel                 rcvdDB6;
char rcvdDB6_Caption[3] = "--";

  TLabel                 rcvdDB7;
char rcvdDB7_Caption[3] = "--";

  TCircle                CANTXIndicator;
  TLabel                 l_CANTX;
char l_CANTX_Caption[7] = "CAN Tx";

  TLabel                 l_text_redled;
char l_text_redled_Caption[47] = "0xAFF0 --> reset blink speed for all leds to 5";

  TLabel                 Label1;
char Label1_Caption[49] = "0xAFF1 --> B0: blink speed RED led (default = 5)";

  TLabel                 Label2;
char Label2_Caption[51] = "0xAFF2 --> B0: blink speed GREEN led (default = 5)";

  TLabel                 Label3;
char Label3_Caption[50] = "0xAFF3 --> B0: blink speed BLUE led (default = 5)";

  TLabel                 Label4;
char Label4_Caption[14] = "CAN commands:";

  TLabel                 Label5;
char Label5_Caption[21] = "received CAN message";

  TLine                  Line1;
  TImage               Image1;
  TLabel                 Label6;
char Label6_Caption[22] = "(Jack Eberson / 2018)";

  TButton                * const code home_Buttons[9]=
         {
         &bRedOn,              
         &bRedOff,             
         &bGreenOn,            
         &bGreenOff,           
         &bBlueOn,             
         &bBlueOff,            
         &bRedBlink,           
         &bGreenBlink,         
         &bBlueBlink           
         };
  TLabel                 * const code home_Labels[23]=
         {
         &MainLabel,           
         &l_ID,                
         &l_DLC,               
         &l_DATA,              
         &l_CANRX,             
         &rcvdID,              
         &rcvdDLC,             
         &rcvdDB0,             
         &rcvdDB1,             
         &rcvdDB2,             
         &rcvdDB3,             
         &rcvdDB4,             
         &rcvdDB5,             
         &rcvdDB6,             
         &rcvdDB7,             
         &l_CANTX,             
         &l_text_redled,       
         &Label1,              
         &Label2,              
         &Label3,              
         &Label4,              
         &Label5,              
         &Label6               
         };
  TImage                 * const code home_Images[1]=
         {
         &Image1               
         };
  TCircle                * const code home_Circles[5]=
         {
         &LedRedIndicator,     
         &LedGreenIndicator,   
         &LedBlueIndicator,    
         &CANRXIndicator,      
         &CANTXIndicator       
         };
  TBox                   * const code home_Boxes[2]=
         {
         &Box1,                
         &dynamicbox_1         
         };
  TLine                  * const code home_Lines[2]=
         {
         &TopLine,             
         &Line1                
         };



static void InitializeObjects() {
  home.Color                     = 0x0418;
  home.Width                     = 480;
  home.Height                    = 272;
  home.ButtonsCount              = 9;
  home.Buttons                   = home_Buttons;
  home.LabelsCount               = 23;
  home.Labels                    = home_Labels;
  home.ImagesCount               = 1;
  home.Images                    = home_Images;
  home.CirclesCount              = 5;
  home.Circles                   = home_Circles;
  home.BoxesCount                = 2;
  home.Boxes                     = home_Boxes;
  home.LinesCount                = 2;
  home.Lines                     = home_Lines;
  home.ObjectsCount              = 42;


  Box1.OwnerScreen     = &home;
  Box1.Order           = 0;
  Box1.Left            = 7;
  Box1.Top             = 211;
  Box1.Width           = 465;
  Box1.Height          = 54;
  Box1.Pen_Width       = 1;
  Box1.Pen_Color       = 0x0000;
  Box1.Visible         = 1;
  Box1.Active          = 1;
  Box1.Transparent     = 1;
  Box1.Gradient        = 1;
  Box1.Gradient_Orientation = 0;
  Box1.Gradient_Start_Color = 0xFFFF;
  Box1.Gradient_End_Color = 0xC618;
  Box1.Color           = 0xFFFF;
  Box1.PressColEnabled = 1;
  Box1.Press_Color     = 0xE71C;
  Box1.OnUpPtr         = 0;
  Box1.OnDownPtr       = 0;
  Box1.OnClickPtr      = 0;
  Box1.OnPressPtr      = 0;

  MainLabel.OwnerScreen     = &home;
  MainLabel.Order           = 1;
  MainLabel.Left            = 20;
  MainLabel.Top             = 11;
  MainLabel.Width           = 170;
  MainLabel.Height          = 23;
  MainLabel.Visible         = 1;
  MainLabel.Active          = 1;
  MainLabel.Caption         = MainLabel_Caption;
  MainLabel.FontName        = Segoe_UI_Symbol16x21_Bold;
  MainLabel.Font_Color      = 0x0010;
  MainLabel.VerticalText    = 0;
  MainLabel.OnUpPtr         = 0;
  MainLabel.OnDownPtr       = 0;
  MainLabel.OnClickPtr      = 0;
  MainLabel.OnPressPtr      = 0;

  bRedOn.OwnerScreen     = &home;
  bRedOn.Order           = 2;
  bRedOn.Left            = 202;
  bRedOn.Top             = 41;
  bRedOn.Width           = 66;
  bRedOn.Height          = 18;
  bRedOn.Pen_Width       = 0;
  bRedOn.Pen_Color       = 0x0010;
  bRedOn.Visible         = 1;
  bRedOn.Active          = 1;
  bRedOn.Transparent     = 1;
  bRedOn.Caption         = bRedOn_Caption;
  bRedOn.TextAlign       = _taCenter;
  bRedOn.TextAlignVertical= _tavMiddle;
  bRedOn.FontName        = Tahoma11x13_Regular;
  bRedOn.PressColEnabled = 1;
  bRedOn.Font_Color      = 0x0000;
  bRedOn.VerticalText    = 0;
  bRedOn.Gradient        = 1;
  bRedOn.Gradient_Orientation = 0;
  bRedOn.Gradient_Start_Color = 0xFFFF;
  bRedOn.Gradient_End_Color = 0xC618;
  bRedOn.Color           = 0xC618;
  bRedOn.Press_Color     = 0xE71C;
  bRedOn.OnUpPtr         = 0;
  bRedOn.OnDownPtr       = 0;
  bRedOn.OnClickPtr      = 0;
  bRedOn.OnPressPtr      = RedOn;

  bRedOff.OwnerScreen     = &home;
  bRedOff.Order           = 3;
  bRedOff.Left            = 382;
  bRedOff.Top             = 41;
  bRedOff.Width           = 66;
  bRedOff.Height          = 18;
  bRedOff.Pen_Width       = 0;
  bRedOff.Pen_Color       = 0x0000;
  bRedOff.Visible         = 1;
  bRedOff.Active          = 1;
  bRedOff.Transparent     = 1;
  bRedOff.Caption         = bRedOff_Caption;
  bRedOff.TextAlign       = _taCenter;
  bRedOff.TextAlignVertical= _tavMiddle;
  bRedOff.FontName        = Tahoma11x13_Regular;
  bRedOff.PressColEnabled = 1;
  bRedOff.Font_Color      = 0x0000;
  bRedOff.VerticalText    = 0;
  bRedOff.Gradient        = 1;
  bRedOff.Gradient_Orientation = 0;
  bRedOff.Gradient_Start_Color = 0xFFFF;
  bRedOff.Gradient_End_Color = 0xC618;
  bRedOff.Color           = 0xC618;
  bRedOff.Press_Color     = 0xE71C;
  bRedOff.OnUpPtr         = 0;
  bRedOff.OnDownPtr       = 0;
  bRedOff.OnClickPtr      = 0;
  bRedOff.OnPressPtr      = RedOff;

  bGreenOn.OwnerScreen     = &home;
  bGreenOn.Order           = 4;
  bGreenOn.Left            = 202;
  bGreenOn.Top             = 73;
  bGreenOn.Width           = 66;
  bGreenOn.Height          = 18;
  bGreenOn.Pen_Width       = 0;
  bGreenOn.Pen_Color       = 0x0010;
  bGreenOn.Visible         = 1;
  bGreenOn.Active          = 1;
  bGreenOn.Transparent     = 1;
  bGreenOn.Caption         = bGreenOn_Caption;
  bGreenOn.TextAlign       = _taCenter;
  bGreenOn.TextAlignVertical= _tavMiddle;
  bGreenOn.FontName        = Tahoma11x13_Regular;
  bGreenOn.PressColEnabled = 1;
  bGreenOn.Font_Color      = 0x0000;
  bGreenOn.VerticalText    = 0;
  bGreenOn.Gradient        = 1;
  bGreenOn.Gradient_Orientation = 0;
  bGreenOn.Gradient_Start_Color = 0xFFFF;
  bGreenOn.Gradient_End_Color = 0xC618;
  bGreenOn.Color           = 0xC618;
  bGreenOn.Press_Color     = 0xE71C;
  bGreenOn.OnUpPtr         = 0;
  bGreenOn.OnDownPtr       = 0;
  bGreenOn.OnClickPtr      = 0;
  bGreenOn.OnPressPtr      = GreenOn;

  bGreenOff.OwnerScreen     = &home;
  bGreenOff.Order           = 5;
  bGreenOff.Left            = 382;
  bGreenOff.Top             = 73;
  bGreenOff.Width           = 66;
  bGreenOff.Height          = 18;
  bGreenOff.Pen_Width       = 0;
  bGreenOff.Pen_Color       = 0x0010;
  bGreenOff.Visible         = 1;
  bGreenOff.Active          = 1;
  bGreenOff.Transparent     = 1;
  bGreenOff.Caption         = bGreenOff_Caption;
  bGreenOff.TextAlign       = _taCenter;
  bGreenOff.TextAlignVertical= _tavMiddle;
  bGreenOff.FontName        = Tahoma11x13_Regular;
  bGreenOff.PressColEnabled = 1;
  bGreenOff.Font_Color      = 0x0000;
  bGreenOff.VerticalText    = 0;
  bGreenOff.Gradient        = 1;
  bGreenOff.Gradient_Orientation = 0;
  bGreenOff.Gradient_Start_Color = 0xFFFF;
  bGreenOff.Gradient_End_Color = 0xC618;
  bGreenOff.Color           = 0xC618;
  bGreenOff.Press_Color     = 0xE71C;
  bGreenOff.OnUpPtr         = 0;
  bGreenOff.OnDownPtr       = 0;
  bGreenOff.OnClickPtr      = 0;
  bGreenOff.OnPressPtr      = GreenOff;

  bBlueOn.OwnerScreen     = &home;
  bBlueOn.Order           = 6;
  bBlueOn.Left            = 202;
  bBlueOn.Top             = 105;
  bBlueOn.Width           = 66;
  bBlueOn.Height          = 18;
  bBlueOn.Pen_Width       = 0;
  bBlueOn.Pen_Color       = 0x0010;
  bBlueOn.Visible         = 1;
  bBlueOn.Active          = 1;
  bBlueOn.Transparent     = 1;
  bBlueOn.Caption         = bBlueOn_Caption;
  bBlueOn.TextAlign       = _taCenter;
  bBlueOn.TextAlignVertical= _tavMiddle;
  bBlueOn.FontName        = Tahoma11x13_Regular;
  bBlueOn.PressColEnabled = 1;
  bBlueOn.Font_Color      = 0x0000;
  bBlueOn.VerticalText    = 0;
  bBlueOn.Gradient        = 1;
  bBlueOn.Gradient_Orientation = 0;
  bBlueOn.Gradient_Start_Color = 0xFFFF;
  bBlueOn.Gradient_End_Color = 0xC618;
  bBlueOn.Color           = 0xC618;
  bBlueOn.Press_Color     = 0xE71C;
  bBlueOn.OnUpPtr         = 0;
  bBlueOn.OnDownPtr       = 0;
  bBlueOn.OnClickPtr      = 0;
  bBlueOn.OnPressPtr      = BlueOn;

  bBlueOff.OwnerScreen     = &home;
  bBlueOff.Order           = 7;
  bBlueOff.Left            = 382;
  bBlueOff.Top             = 105;
  bBlueOff.Width           = 66;
  bBlueOff.Height          = 18;
  bBlueOff.Pen_Width       = 0;
  bBlueOff.Pen_Color       = 0x0010;
  bBlueOff.Visible         = 1;
  bBlueOff.Active          = 1;
  bBlueOff.Transparent     = 1;
  bBlueOff.Caption         = bBlueOff_Caption;
  bBlueOff.TextAlign       = _taCenter;
  bBlueOff.TextAlignVertical= _tavMiddle;
  bBlueOff.FontName        = Tahoma11x13_Regular;
  bBlueOff.PressColEnabled = 1;
  bBlueOff.Font_Color      = 0x0000;
  bBlueOff.VerticalText    = 0;
  bBlueOff.Gradient        = 1;
  bBlueOff.Gradient_Orientation = 0;
  bBlueOff.Gradient_Start_Color = 0xFFFF;
  bBlueOff.Gradient_End_Color = 0xC618;
  bBlueOff.Color           = 0xC618;
  bBlueOff.Press_Color     = 0xE71C;
  bBlueOff.OnUpPtr         = 0;
  bBlueOff.OnDownPtr       = 0;
  bBlueOff.OnClickPtr      = 0;
  bBlueOff.OnPressPtr      = BlueOff;

  bRedBlink.OwnerScreen     = &home;
  bRedBlink.Order           = 8;
  bRedBlink.Left            = 290;
  bRedBlink.Top             = 41;
  bRedBlink.Width           = 69;
  bRedBlink.Height          = 18;
  bRedBlink.Pen_Width       = 0;
  bRedBlink.Pen_Color       = 0x0000;
  bRedBlink.Visible         = 1;
  bRedBlink.Active          = 1;
  bRedBlink.Transparent     = 1;
  bRedBlink.Caption         = bRedBlink_Caption;
  bRedBlink.TextAlign       = _taCenter;
  bRedBlink.TextAlignVertical= _tavMiddle;
  bRedBlink.FontName        = Tahoma11x13_Regular;
  bRedBlink.PressColEnabled = 1;
  bRedBlink.Font_Color      = 0x0000;
  bRedBlink.VerticalText    = 0;
  bRedBlink.Gradient        = 1;
  bRedBlink.Gradient_Orientation = 0;
  bRedBlink.Gradient_Start_Color = 0xFFFF;
  bRedBlink.Gradient_End_Color = 0xC618;
  bRedBlink.Color           = 0xC618;
  bRedBlink.Press_Color     = 0xE71C;
  bRedBlink.OnUpPtr         = 0;
  bRedBlink.OnDownPtr       = 0;
  bRedBlink.OnClickPtr      = 0;
  bRedBlink.OnPressPtr      = RedBlink;

  bGreenBlink.OwnerScreen     = &home;
  bGreenBlink.Order           = 9;
  bGreenBlink.Left            = 290;
  bGreenBlink.Top             = 73;
  bGreenBlink.Width           = 69;
  bGreenBlink.Height          = 18;
  bGreenBlink.Pen_Width       = 0;
  bGreenBlink.Pen_Color       = 0x0010;
  bGreenBlink.Visible         = 1;
  bGreenBlink.Active          = 1;
  bGreenBlink.Transparent     = 1;
  bGreenBlink.Caption         = bGreenBlink_Caption;
  bGreenBlink.TextAlign       = _taCenter;
  bGreenBlink.TextAlignVertical= _tavMiddle;
  bGreenBlink.FontName        = Tahoma11x13_Regular;
  bGreenBlink.PressColEnabled = 1;
  bGreenBlink.Font_Color      = 0x0000;
  bGreenBlink.VerticalText    = 0;
  bGreenBlink.Gradient        = 1;
  bGreenBlink.Gradient_Orientation = 0;
  bGreenBlink.Gradient_Start_Color = 0xFFFF;
  bGreenBlink.Gradient_End_Color = 0xC618;
  bGreenBlink.Color           = 0xC618;
  bGreenBlink.Press_Color     = 0xE71C;
  bGreenBlink.OnUpPtr         = 0;
  bGreenBlink.OnDownPtr       = 0;
  bGreenBlink.OnClickPtr      = 0;
  bGreenBlink.OnPressPtr      = GreenBlink;

  bBlueBlink.OwnerScreen     = &home;
  bBlueBlink.Order           = 10;
  bBlueBlink.Left            = 290;
  bBlueBlink.Top             = 105;
  bBlueBlink.Width           = 69;
  bBlueBlink.Height          = 18;
  bBlueBlink.Pen_Width       = 0;
  bBlueBlink.Pen_Color       = 0x0010;
  bBlueBlink.Visible         = 1;
  bBlueBlink.Active          = 1;
  bBlueBlink.Transparent     = 1;
  bBlueBlink.Caption         = bBlueBlink_Caption;
  bBlueBlink.TextAlign       = _taCenter;
  bBlueBlink.TextAlignVertical= _tavMiddle;
  bBlueBlink.FontName        = Tahoma11x13_Regular;
  bBlueBlink.PressColEnabled = 1;
  bBlueBlink.Font_Color      = 0x0000;
  bBlueBlink.VerticalText    = 0;
  bBlueBlink.Gradient        = 1;
  bBlueBlink.Gradient_Orientation = 0;
  bBlueBlink.Gradient_Start_Color = 0xFFFF;
  bBlueBlink.Gradient_End_Color = 0xC618;
  bBlueBlink.Color           = 0xC618;
  bBlueBlink.Press_Color     = 0xE71C;
  bBlueBlink.OnUpPtr         = 0;
  bBlueBlink.OnDownPtr       = 0;
  bBlueBlink.OnClickPtr      = 0;
  bBlueBlink.OnPressPtr      = BlueBlink;

  TopLine.OwnerScreen     = &home;
  TopLine.Order           = 11;
  TopLine.First_Point_X   = 10;
  TopLine.First_Point_Y   = 33;
  TopLine.Second_Point_X  = 470;
  TopLine.Second_Point_Y  = 33;
  TopLine.Visible         = 1;
  TopLine.Pen_Width       = 2;
  TopLine.Color           = 0x0010;

  LedRedIndicator.OwnerScreen     = &home;
  LedRedIndicator.Order           = 12;
  LedRedIndicator.Left            = 166;
  LedRedIndicator.Top             = 42;
  LedRedIndicator.Radius          = 8;
  LedRedIndicator.Pen_Width       = 1;
  LedRedIndicator.Pen_Color       = 0xF800;
  LedRedIndicator.Visible         = 1;
  LedRedIndicator.Active          = 1;
  LedRedIndicator.Transparent     = 0;
  LedRedIndicator.Gradient        = 1;
  LedRedIndicator.Gradient_Orientation = 0;
  LedRedIndicator.Gradient_Start_Color = 0xFFFF;
  LedRedIndicator.Gradient_End_Color = 0xC618;
  LedRedIndicator.Color           = 0xC618;
  LedRedIndicator.PressColEnabled = 1;
  LedRedIndicator.Press_Color     = 0xE71C;
  LedRedIndicator.OnUpPtr         = 0;
  LedRedIndicator.OnDownPtr       = 0;
  LedRedIndicator.OnClickPtr      = 0;
  LedRedIndicator.OnPressPtr      = 0;

  LedGreenIndicator.OwnerScreen     = &home;
  LedGreenIndicator.Order           = 13;
  LedGreenIndicator.Left            = 166;
  LedGreenIndicator.Top             = 74;
  LedGreenIndicator.Radius          = 8;
  LedGreenIndicator.Pen_Width       = 1;
  LedGreenIndicator.Pen_Color       = 0x0400;
  LedGreenIndicator.Visible         = 1;
  LedGreenIndicator.Active          = 1;
  LedGreenIndicator.Transparent     = 0;
  LedGreenIndicator.Gradient        = 1;
  LedGreenIndicator.Gradient_Orientation = 0;
  LedGreenIndicator.Gradient_Start_Color = 0xFFFF;
  LedGreenIndicator.Gradient_End_Color = 0xC618;
  LedGreenIndicator.Color           = 0xC618;
  LedGreenIndicator.PressColEnabled = 1;
  LedGreenIndicator.Press_Color     = 0xE71C;
  LedGreenIndicator.OnUpPtr         = 0;
  LedGreenIndicator.OnDownPtr       = 0;
  LedGreenIndicator.OnClickPtr      = 0;
  LedGreenIndicator.OnPressPtr      = 0;

  LedBlueIndicator.OwnerScreen     = &home;
  LedBlueIndicator.Order           = 14;
  LedBlueIndicator.Left            = 166;
  LedBlueIndicator.Top             = 106;
  LedBlueIndicator.Radius          = 8;
  LedBlueIndicator.Pen_Width       = 1;
  LedBlueIndicator.Pen_Color       = 0x001F;
  LedBlueIndicator.Visible         = 1;
  LedBlueIndicator.Active          = 1;
  LedBlueIndicator.Transparent     = 0;
  LedBlueIndicator.Gradient        = 1;
  LedBlueIndicator.Gradient_Orientation = 0;
  LedBlueIndicator.Gradient_Start_Color = 0xFFFF;
  LedBlueIndicator.Gradient_End_Color = 0xC618;
  LedBlueIndicator.Color           = 0xC618;
  LedBlueIndicator.PressColEnabled = 1;
  LedBlueIndicator.Press_Color     = 0xE71C;
  LedBlueIndicator.OnUpPtr         = 0;
  LedBlueIndicator.OnDownPtr       = 0;
  LedBlueIndicator.OnClickPtr      = 0;
  LedBlueIndicator.OnPressPtr      = 0;

  l_ID.OwnerScreen     = &home;
  l_ID.Order           = 15;
  l_ID.Left            = 261;
  l_ID.Top             = 216;
  l_ID.Width           = 20;
  l_ID.Height          = 15;
  l_ID.Visible         = 1;
  l_ID.Active          = 1;
  l_ID.Caption         = l_ID_Caption;
  l_ID.FontName        = Tahoma11x13_Regular;
  l_ID.Font_Color      = 0x0010;
  l_ID.VerticalText    = 0;
  l_ID.OnUpPtr         = 0;
  l_ID.OnDownPtr       = 0;
  l_ID.OnClickPtr      = 0;
  l_ID.OnPressPtr      = 0;

  l_DLC.OwnerScreen     = &home;
  l_DLC.Order           = 16;
  l_DLC.Left            = 253;
  l_DLC.Top             = 231;
  l_DLC.Width           = 28;
  l_DLC.Height          = 15;
  l_DLC.Visible         = 1;
  l_DLC.Active          = 1;
  l_DLC.Caption         = l_DLC_Caption;
  l_DLC.FontName        = Tahoma11x13_Regular;
  l_DLC.Font_Color      = 0x0010;
  l_DLC.VerticalText    = 0;
  l_DLC.OnUpPtr         = 0;
  l_DLC.OnDownPtr       = 0;
  l_DLC.OnClickPtr      = 0;
  l_DLC.OnPressPtr      = 0;

  l_DATA.OwnerScreen     = &home;
  l_DATA.Order           = 17;
  l_DATA.Left            = 245;
  l_DATA.Top             = 247;
  l_DATA.Width           = 36;
  l_DATA.Height          = 15;
  l_DATA.Visible         = 1;
  l_DATA.Active          = 1;
  l_DATA.Caption         = l_DATA_Caption;
  l_DATA.FontName        = Tahoma11x13_Regular;
  l_DATA.Font_Color      = 0x0010;
  l_DATA.VerticalText    = 0;
  l_DATA.OnUpPtr         = 0;
  l_DATA.OnDownPtr       = 0;
  l_DATA.OnClickPtr      = 0;
  l_DATA.OnPressPtr      = 0;

  CANRXIndicator.OwnerScreen     = &home;
  CANRXIndicator.Order           = 18;
  CANRXIndicator.Left            = 15;
  CANRXIndicator.Top             = 241;
  CANRXIndicator.Radius          = 8;
  CANRXIndicator.Pen_Width       = 1;
  CANRXIndicator.Pen_Color       = 0xFFE0;
  CANRXIndicator.Visible         = 1;
  CANRXIndicator.Active          = 1;
  CANRXIndicator.Transparent     = 0;
  CANRXIndicator.Gradient        = 1;
  CANRXIndicator.Gradient_Orientation = 0;
  CANRXIndicator.Gradient_Start_Color = 0xFFFF;
  CANRXIndicator.Gradient_End_Color = 0xC618;
  CANRXIndicator.Color           = 0xC618;
  CANRXIndicator.PressColEnabled = 1;
  CANRXIndicator.Press_Color     = 0xE71C;
  CANRXIndicator.OnUpPtr         = 0;
  CANRXIndicator.OnDownPtr       = 0;
  CANRXIndicator.OnClickPtr      = 0;
  CANRXIndicator.OnPressPtr      = 0;

  l_CANRX.OwnerScreen     = &home;
  l_CANRX.Order           = 19;
  l_CANRX.Left            = 37;
  l_CANRX.Top             = 243;
  l_CANRX.Width           = 41;
  l_CANRX.Height          = 15;
  l_CANRX.Visible         = 1;
  l_CANRX.Active          = 1;
  l_CANRX.Caption         = l_CANRX_Caption;
  l_CANRX.FontName        = Tahoma11x13_Regular;
  l_CANRX.Font_Color      = 0x0010;
  l_CANRX.VerticalText    = 0;
  l_CANRX.OnUpPtr         = 0;
  l_CANRX.OnDownPtr       = 0;
  l_CANRX.OnClickPtr      = 0;
  l_CANRX.OnPressPtr      = 0;

  dynamicbox_1.OwnerScreen     = &home;
  dynamicbox_1.Order           = 20;
  dynamicbox_1.Left            = 279;
  dynamicbox_1.Top             = 212;
  dynamicbox_1.Width           = 180;
  dynamicbox_1.Height          = 52;
  dynamicbox_1.Pen_Width       = 0;
  dynamicbox_1.Pen_Color       = 0x0000;
  dynamicbox_1.Visible         = 1;
  dynamicbox_1.Active          = 1;
  dynamicbox_1.Transparent     = 1;
  dynamicbox_1.Gradient        = 1;
  dynamicbox_1.Gradient_Orientation = 0;
  dynamicbox_1.Gradient_Start_Color = 0xFFFF;
  dynamicbox_1.Gradient_End_Color = 0xC618;
  dynamicbox_1.Color           = 0xC618;
  dynamicbox_1.PressColEnabled = 0;
  dynamicbox_1.Press_Color     = 0xE71C;
  dynamicbox_1.OnUpPtr         = 0;
  dynamicbox_1.OnDownPtr       = 0;
  dynamicbox_1.OnClickPtr      = 0;
  dynamicbox_1.OnPressPtr      = 0;

  rcvdID.OwnerScreen     = &home;
  rcvdID.Order           = 21;
  rcvdID.Left            = 281;
  rcvdID.Top             = 216;
  rcvdID.Width           = 12;
  rcvdID.Height          = 15;
  rcvdID.Visible         = 1;
  rcvdID.Active          = 1;
  rcvdID.Caption         = rcvdID_Caption;
  rcvdID.FontName        = Tahoma11x13_Regular;
  rcvdID.Font_Color      = 0x0010;
  rcvdID.VerticalText    = 0;
  rcvdID.OnUpPtr         = 0;
  rcvdID.OnDownPtr       = 0;
  rcvdID.OnClickPtr      = 0;
  rcvdID.OnPressPtr      = 0;

  rcvdDLC.OwnerScreen     = &home;
  rcvdDLC.Order           = 22;
  rcvdDLC.Left            = 281;
  rcvdDLC.Top             = 231;
  rcvdDLC.Width           = 12;
  rcvdDLC.Height          = 15;
  rcvdDLC.Visible         = 1;
  rcvdDLC.Active          = 1;
  rcvdDLC.Caption         = rcvdDLC_Caption;
  rcvdDLC.FontName        = Tahoma11x13_Regular;
  rcvdDLC.Font_Color      = 0x0010;
  rcvdDLC.VerticalText    = 0;
  rcvdDLC.OnUpPtr         = 0;
  rcvdDLC.OnDownPtr       = 0;
  rcvdDLC.OnClickPtr      = 0;
  rcvdDLC.OnPressPtr      = 0;

  rcvdDB0.OwnerScreen     = &home;
  rcvdDB0.Order           = 23;
  rcvdDB0.Left            = 281;
  rcvdDB0.Top             = 247;
  rcvdDB0.Width           = 12;
  rcvdDB0.Height          = 15;
  rcvdDB0.Visible         = 1;
  rcvdDB0.Active          = 1;
  rcvdDB0.Caption         = rcvdDB0_Caption;
  rcvdDB0.FontName        = Tahoma11x13_Regular;
  rcvdDB0.Font_Color      = 0x0010;
  rcvdDB0.VerticalText    = 0;
  rcvdDB0.OnUpPtr         = 0;
  rcvdDB0.OnDownPtr       = 0;
  rcvdDB0.OnClickPtr      = 0;
  rcvdDB0.OnPressPtr      = 0;

  rcvdDB1.OwnerScreen     = &home;
  rcvdDB1.Order           = 24;
  rcvdDB1.Left            = 304;
  rcvdDB1.Top             = 247;
  rcvdDB1.Width           = 12;
  rcvdDB1.Height          = 15;
  rcvdDB1.Visible         = 1;
  rcvdDB1.Active          = 1;
  rcvdDB1.Caption         = rcvdDB1_Caption;
  rcvdDB1.FontName        = Tahoma11x13_Regular;
  rcvdDB1.Font_Color      = 0x0010;
  rcvdDB1.VerticalText    = 0;
  rcvdDB1.OnUpPtr         = 0;
  rcvdDB1.OnDownPtr       = 0;
  rcvdDB1.OnClickPtr      = 0;
  rcvdDB1.OnPressPtr      = 0;

  rcvdDB2.OwnerScreen     = &home;
  rcvdDB2.Order           = 25;
  rcvdDB2.Left            = 327;
  rcvdDB2.Top             = 247;
  rcvdDB2.Width           = 12;
  rcvdDB2.Height          = 15;
  rcvdDB2.Visible         = 1;
  rcvdDB2.Active          = 1;
  rcvdDB2.Caption         = rcvdDB2_Caption;
  rcvdDB2.FontName        = Tahoma11x13_Regular;
  rcvdDB2.Font_Color      = 0x0010;
  rcvdDB2.VerticalText    = 0;
  rcvdDB2.OnUpPtr         = 0;
  rcvdDB2.OnDownPtr       = 0;
  rcvdDB2.OnClickPtr      = 0;
  rcvdDB2.OnPressPtr      = 0;

  rcvdDB3.OwnerScreen     = &home;
  rcvdDB3.Order           = 26;
  rcvdDB3.Left            = 350;
  rcvdDB3.Top             = 247;
  rcvdDB3.Width           = 12;
  rcvdDB3.Height          = 15;
  rcvdDB3.Visible         = 1;
  rcvdDB3.Active          = 1;
  rcvdDB3.Caption         = rcvdDB3_Caption;
  rcvdDB3.FontName        = Tahoma11x13_Regular;
  rcvdDB3.Font_Color      = 0x0010;
  rcvdDB3.VerticalText    = 0;
  rcvdDB3.OnUpPtr         = 0;
  rcvdDB3.OnDownPtr       = 0;
  rcvdDB3.OnClickPtr      = 0;
  rcvdDB3.OnPressPtr      = 0;

  rcvdDB4.OwnerScreen     = &home;
  rcvdDB4.Order           = 27;
  rcvdDB4.Left            = 374;
  rcvdDB4.Top             = 247;
  rcvdDB4.Width           = 12;
  rcvdDB4.Height          = 15;
  rcvdDB4.Visible         = 1;
  rcvdDB4.Active          = 1;
  rcvdDB4.Caption         = rcvdDB4_Caption;
  rcvdDB4.FontName        = Tahoma11x13_Regular;
  rcvdDB4.Font_Color      = 0x0010;
  rcvdDB4.VerticalText    = 0;
  rcvdDB4.OnUpPtr         = 0;
  rcvdDB4.OnDownPtr       = 0;
  rcvdDB4.OnClickPtr      = 0;
  rcvdDB4.OnPressPtr      = 0;

  rcvdDB5.OwnerScreen     = &home;
  rcvdDB5.Order           = 28;
  rcvdDB5.Left            = 397;
  rcvdDB5.Top             = 247;
  rcvdDB5.Width           = 12;
  rcvdDB5.Height          = 15;
  rcvdDB5.Visible         = 1;
  rcvdDB5.Active          = 1;
  rcvdDB5.Caption         = rcvdDB5_Caption;
  rcvdDB5.FontName        = Tahoma11x13_Regular;
  rcvdDB5.Font_Color      = 0x0010;
  rcvdDB5.VerticalText    = 0;
  rcvdDB5.OnUpPtr         = 0;
  rcvdDB5.OnDownPtr       = 0;
  rcvdDB5.OnClickPtr      = 0;
  rcvdDB5.OnPressPtr      = 0;

  rcvdDB6.OwnerScreen     = &home;
  rcvdDB6.Order           = 29;
  rcvdDB6.Left            = 420;
  rcvdDB6.Top             = 247;
  rcvdDB6.Width           = 12;
  rcvdDB6.Height          = 15;
  rcvdDB6.Visible         = 1;
  rcvdDB6.Active          = 1;
  rcvdDB6.Caption         = rcvdDB6_Caption;
  rcvdDB6.FontName        = Tahoma11x13_Regular;
  rcvdDB6.Font_Color      = 0x0010;
  rcvdDB6.VerticalText    = 0;
  rcvdDB6.OnUpPtr         = 0;
  rcvdDB6.OnDownPtr       = 0;
  rcvdDB6.OnClickPtr      = 0;
  rcvdDB6.OnPressPtr      = 0;

  rcvdDB7.OwnerScreen     = &home;
  rcvdDB7.Order           = 30;
  rcvdDB7.Left            = 443;
  rcvdDB7.Top             = 247;
  rcvdDB7.Width           = 12;
  rcvdDB7.Height          = 15;
  rcvdDB7.Visible         = 1;
  rcvdDB7.Active          = 1;
  rcvdDB7.Caption         = rcvdDB7_Caption;
  rcvdDB7.FontName        = Tahoma11x13_Regular;
  rcvdDB7.Font_Color      = 0x0010;
  rcvdDB7.VerticalText    = 0;
  rcvdDB7.OnUpPtr         = 0;
  rcvdDB7.OnDownPtr       = 0;
  rcvdDB7.OnClickPtr      = 0;
  rcvdDB7.OnPressPtr      = 0;

  CANTXIndicator.OwnerScreen     = &home;
  CANTXIndicator.Order           = 31;
  CANTXIndicator.Left            = 15;
  CANTXIndicator.Top             = 219;
  CANTXIndicator.Radius          = 8;
  CANTXIndicator.Pen_Width       = 1;
  CANTXIndicator.Pen_Color       = 0xFFE0;
  CANTXIndicator.Visible         = 1;
  CANTXIndicator.Active          = 1;
  CANTXIndicator.Transparent     = 0;
  CANTXIndicator.Gradient        = 1;
  CANTXIndicator.Gradient_Orientation = 0;
  CANTXIndicator.Gradient_Start_Color = 0xFFFF;
  CANTXIndicator.Gradient_End_Color = 0xC618;
  CANTXIndicator.Color           = 0xC618;
  CANTXIndicator.PressColEnabled = 1;
  CANTXIndicator.Press_Color     = 0xE71C;
  CANTXIndicator.OnUpPtr         = 0;
  CANTXIndicator.OnDownPtr       = 0;
  CANTXIndicator.OnClickPtr      = 0;
  CANTXIndicator.OnPressPtr      = 0;

  l_CANTX.OwnerScreen     = &home;
  l_CANTX.Order           = 32;
  l_CANTX.Left            = 37;
  l_CANTX.Top             = 221;
  l_CANTX.Width           = 41;
  l_CANTX.Height          = 15;
  l_CANTX.Visible         = 1;
  l_CANTX.Active          = 1;
  l_CANTX.Caption         = l_CANTX_Caption;
  l_CANTX.FontName        = Tahoma11x13_Regular;
  l_CANTX.Font_Color      = 0x0010;
  l_CANTX.VerticalText    = 0;
  l_CANTX.OnUpPtr         = 0;
  l_CANTX.OnDownPtr       = 0;
  l_CANTX.OnClickPtr      = 0;
  l_CANTX.OnPressPtr      = 0;

  l_text_redled.OwnerScreen     = &home;
  l_text_redled.Order           = 33;
  l_text_redled.Left            = 63;
  l_text_redled.Top             = 158;
  l_text_redled.Width           = 226;
  l_text_redled.Height          = 14;
  l_text_redled.Visible         = 1;
  l_text_redled.Active          = 1;
  l_text_redled.Caption         = l_text_redled_Caption;
  l_text_redled.FontName        = Arial11x14_Regular;
  l_text_redled.Font_Color      = 0x0010;
  l_text_redled.VerticalText    = 0;
  l_text_redled.OnUpPtr         = 0;
  l_text_redled.OnDownPtr       = 0;
  l_text_redled.OnClickPtr      = 0;
  l_text_redled.OnPressPtr      = 0;

  Label1.OwnerScreen     = &home;
  Label1.Order           = 34;
  Label1.Left            = 63;
  Label1.Top             = 171;
  Label1.Width           = 251;
  Label1.Height          = 14;
  Label1.Visible         = 1;
  Label1.Active          = 1;
  Label1.Caption         = Label1_Caption;
  Label1.FontName        = Arial11x14_Regular;
  Label1.Font_Color      = 0x0010;
  Label1.VerticalText    = 0;
  Label1.OnUpPtr         = 0;
  Label1.OnDownPtr       = 0;
  Label1.OnClickPtr      = 0;
  Label1.OnPressPtr      = 0;

  Label2.OwnerScreen     = &home;
  Label2.Order           = 35;
  Label2.Left            = 62;
  Label2.Top             = 184;
  Label2.Width           = 267;
  Label2.Height          = 14;
  Label2.Visible         = 1;
  Label2.Active          = 1;
  Label2.Caption         = Label2_Caption;
  Label2.FontName        = Arial11x14_Regular;
  Label2.Font_Color      = 0x0010;
  Label2.VerticalText    = 0;
  Label2.OnUpPtr         = 0;
  Label2.OnDownPtr       = 0;
  Label2.OnClickPtr      = 0;
  Label2.OnPressPtr      = 0;

  Label3.OwnerScreen     = &home;
  Label3.Order           = 36;
  Label3.Left            = 63;
  Label3.Top             = 197;
  Label3.Width           = 256;
  Label3.Height          = 14;
  Label3.Visible         = 1;
  Label3.Active          = 1;
  Label3.Caption         = Label3_Caption;
  Label3.FontName        = Arial11x14_Regular;
  Label3.Font_Color      = 0x0010;
  Label3.VerticalText    = 0;
  Label3.OnUpPtr         = 0;
  Label3.OnDownPtr       = 0;
  Label3.OnClickPtr      = 0;
  Label3.OnPressPtr      = 0;

  Label4.OwnerScreen     = &home;
  Label4.Order           = 37;
  Label4.Left            = 31;
  Label4.Top             = 141;
  Label4.Width           = 106;
  Label4.Height          = 16;
  Label4.Visible         = 1;
  Label4.Active          = 1;
  Label4.Caption         = Label4_Caption;
  Label4.FontName        = Arial13x16_ItalicUnderLine;
  Label4.Font_Color      = 0x0010;
  Label4.VerticalText    = 0;
  Label4.OnUpPtr         = 0;
  Label4.OnDownPtr       = 0;
  Label4.OnClickPtr      = 0;
  Label4.OnPressPtr      = 0;

  Label5.OwnerScreen     = &home;
  Label5.Order           = 38;
  Label5.Left            = 112;
  Label5.Top             = 216;
  Label5.Width           = 128;
  Label5.Height          = 16;
  Label5.Visible         = 1;
  Label5.Active          = 1;
  Label5.Caption         = Label5_Caption;
  Label5.FontName        = Tahoma12x14_Regular;
  Label5.Font_Color      = 0x0010;
  Label5.VerticalText    = 0;
  Label5.OnUpPtr         = 0;
  Label5.OnDownPtr       = 0;
  Label5.OnClickPtr      = 0;
  Label5.OnPressPtr      = 0;

  Line1.OwnerScreen     = &home;
  Line1.Order           = 39;
  Line1.First_Point_X   = 91;
  Line1.First_Point_Y   = 214;
  Line1.Second_Point_X  = 91;
  Line1.Second_Point_Y  = 262;
  Line1.Visible         = 1;
  Line1.Pen_Width       = 2;
  Line1.Color           = 0x0010;

  Image1.OwnerScreen     = &home;
  Image1.Order           = 40;
  Image1.Left            = 40;
  Image1.Top             = 38;
  Image1.Width           = 100;
  Image1.Height          = 100;
  Image1.Picture_Type    = 0;
  Image1.Picture_Ratio   = 1;
  Image1.Picture_Name    = RGBled_bmp;
  Image1.Visible         = 1;
  Image1.Active          = 1;
  Image1.OnUpPtr         = 0;
  Image1.OnDownPtr       = 0;
  Image1.OnClickPtr      = 0;
  Image1.OnPressPtr      = 0;

  Label6.OwnerScreen     = &home;
  Label6.Order           = 41;
  Label6.Left            = 334;
  Label6.Top             = 18;
  Label6.Width           = 125;
  Label6.Height          = 15;
  Label6.Visible         = 1;
  Label6.Active          = 1;
  Label6.Caption         = Label6_Caption;
  Label6.FontName        = Arial12x15_Regular;
  Label6.Font_Color      = 0x0010;
  Label6.VerticalText    = 0;
  Label6.OnUpPtr         = 0;
  Label6.OnDownPtr       = 0;
  Label6.OnClickPtr      = 0;
  Label6.OnPressPtr      = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetButton(index)              CurrentScreen->Buttons[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetImage(index)               CurrentScreen->Images[index]
#define GetCircle(index)              CurrentScreen->Circles[index]
#define GetBox(index)                 CurrentScreen->Boxes[index]
#define GetLine(index)                CurrentScreen->Lines[index]

void DrawButton(TButton *Abutton) {
unsigned int ALeft, ATop;
  if (Abutton->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
    }
    TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
    TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
    if (Abutton->VerticalText != 0)
      TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_VERTICAL_COLUMN);
    else
      TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
    if (Abutton->TextAlign == _taLeft)
      ALeft = Abutton->Left + 4;
    else if (Abutton->TextAlign == _taCenter)
      ALeft = Abutton->Left + (Abutton->Width - caption_length) / 2;
    else if (Abutton->TextAlign == _taRight)
      ALeft = Abutton->Left + Abutton->Width - caption_length - 4;

    if (Abutton->TextAlignVertical == _tavTop)
      ATop = Abutton->Top + 4;
    else if (Abutton->TextAlignVertical == _tavMiddle)
      ATop = Abutton->Top + ((Abutton->Height - caption_height) / 2);
    else if (Abutton->TextAlignVertical == _tavBottom)
      ATop = Abutton->Top + (Abutton->Height - caption_height - 4);

    TFT_Write_Text(Abutton->Caption, ALeft, ATop);
  }
}

void DrawLabel(TLabel *ALabel) {
  if (ALabel->Visible != 0) {
    if (ALabel->VerticalText != 0)
      TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_VERTICAL_COLUMN);
    else
      TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawImage(TImage *AImage) {
  if (AImage->Visible != 0) {
    TFT_Image(AImage->Left, AImage->Top, AImage->Picture_Name, AImage->Picture_Ratio);
  }
}

void DrawCircle(TCircle *ACircle) {
  if (ACircle->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ACircle->Transparent, ACircle->Press_Color, ACircle->Gradient, ACircle->Gradient_Orientation,
                    ACircle->Gradient_End_Color, ACircle->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ACircle->Transparent, ACircle->Color, ACircle->Gradient, ACircle->Gradient_Orientation,
                    ACircle->Gradient_Start_Color, ACircle->Gradient_End_Color);
    }
    TFT_Set_Pen(ACircle->Pen_Color, ACircle->Pen_Width);
    TFT_Circle(ACircle->Left + ACircle->Radius,
               ACircle->Top + ACircle->Radius,
               ACircle->Radius);
  }
}

void DrawBox(TBox *ABox) {
  if (ABox->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
    }
    TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
    TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
  }
}

void DrawLine(TLine *Aline) {
  if (Aline->Visible != 0) {
    TFT_Set_Pen(Aline->Color, Aline->Pen_Width);
    TFT_Line(Aline->First_Point_X, Aline->First_Point_Y, Aline->Second_Point_X, Aline->Second_Point_Y);
  }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
  unsigned short button_idx;
  TButton *local_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short image_idx;
  TImage *local_image;
  unsigned short circle_idx;
  TCircle *local_circle;
  unsigned short box_idx;
  TBox *local_box;
  unsigned short line_idx;
  TLine *local_line;
  char save_bled;

  object_pressed = 0;
  order = 0;
  button_idx = 0;
  label_idx = 0;
  image_idx = 0;
  circle_idx = 0;
  box_idx = 0;
  line_idx = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
    save_bled = TFT_BLED;
    TFT_BLED           = 0;
    TFT_Set_Active(Set_Index, Write_Command, Write_Data);
    TFT_Init_SSD1963(CurrentScreen->Width, CurrentScreen->Height);
    STMPE610_SetSize(CurrentScreen->Width, CurrentScreen->Height);
    TFT_Fill_Screen(CurrentScreen->Color);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_BLED           = save_bled;
  }
  else
    TFT_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (button_idx < CurrentScreen->ButtonsCount) {
      local_button = GetButton(button_idx);
      if (order == local_button->Order) {
        button_idx++;
        order++;
        DrawButton(local_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (circle_idx < CurrentScreen->CirclesCount) {
      local_circle = GetCircle(circle_idx);
      if (order == local_circle->Order) {
        circle_idx++;
        order++;
        DrawCircle(local_circle);
      }
    }

    if (box_idx < CurrentScreen->BoxesCount) {
      local_box = GetBox(box_idx);
      if (order == local_box->Order) {
        box_idx++;
        order++;
        DrawBox(local_box);
      }
    }

    if (line_idx < CurrentScreen->LinesCount) {
      local_line = GetLine(line_idx);
      if (order == local_line->Order) {
        line_idx++;
        order++;
        DrawLine(local_line);
      }
    }

    if (image_idx < CurrentScreen->ImagesCount) {
      local_image = GetImage(image_idx);
      if (order == local_image->Order) {
        image_idx++;
        order++;
        DrawImage(local_image);
      }
    }

  }
}

void Get_Object(unsigned int X, unsigned int Y) {
  button_order        = -1;
  label_order         = -1;
  image_order         = -1;
  circle_order        = -1;
  box_order           = -1;
  //  Buttons
  for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
    local_button = GetButton(_object_count);
    if (local_button->Active != 0) {
      if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
                         local_button->Width, local_button->Height) == 1) {
        button_order = local_button->Order;
        exec_button = local_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel(_object_count);
    if (local_label->Active != 0) {
      if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height) == 1) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  //  Images
  for ( _object_count = 0 ; _object_count < CurrentScreen->ImagesCount ; _object_count++ ) {
    local_image = GetImage(_object_count);
    if (local_image->Active != 0) {
      if (IsInsideObject(X, Y, local_image->Left, local_image->Top,
                         local_image->Width, local_image->Height) == 1) {
        image_order = local_image->Order;
        exec_image = local_image;
      }
    }
  }

  //  Circles
  for ( _object_count = 0 ; _object_count < CurrentScreen->CirclesCount ; _object_count++ ) {
    local_circle = GetCircle(_object_count);
    if (local_circle->Active != 0) {
      if (IsInsideObject(X, Y, local_circle->Left, local_circle->Top,
                        (local_circle->Radius * 2), (local_circle->Radius * 2)) == 1) {
        circle_order = local_circle->Order;
        exec_circle = local_circle;
      }
    }
  }

  //  Boxes
  for ( _object_count = 0 ; _object_count < CurrentScreen->BoxesCount ; _object_count++ ) {
    local_box = GetBox(_object_count);
    if (local_box->Active != 0) {
      if (IsInsideObject(X, Y, local_box->Left, local_box->Top,
                         local_box->Width, local_box->Height) == 1) {
        box_order = local_box->Order;
        exec_box = local_box;
      }
    }
  }

  _object_count = -1;
  if (button_order >  _object_count )
    _object_count = button_order;
  if (label_order >  _object_count )
    _object_count = label_order;
  if (image_order >  _object_count )
    _object_count = image_order;
  if (circle_order >  _object_count )
    _object_count = circle_order;
  if (box_order >  _object_count )
    _object_count = box_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
  exec_button         = 0;
  exec_label          = 0;
  exec_image          = 0;
  exec_circle         = 0;
  exec_box            = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->OnPressPtr != 0) {
          exec_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnPressPtr != 0) {
          exec_label->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == image_order) {
      if (exec_image->Active != 0) {
        if (exec_image->OnPressPtr != 0) {
          exec_image->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == circle_order) {
      if (exec_circle->Active != 0) {
        if (exec_circle->OnPressPtr != 0) {
          exec_circle->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active != 0) {
        if (exec_box->OnPressPtr != 0) {
          exec_box->OnPressPtr();
          return;
        }
      }
    }

  }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

  switch (PressedObjectType) {
    // Button
    case 0: {
      if (PressedObject != 0) {
        exec_button = (TButton*)PressedObject;
        if ((exec_button->PressColEnabled != 0) && (exec_button->OwnerScreen == CurrentScreen)) {
          DrawButton(exec_button);
        }
        break;
      }
      break;
    }
    // Circle
    case 4: {
      if (PressedObject != 0) {
        exec_circle = (TCircle*)PressedObject;
        if ((exec_circle->PressColEnabled != 0) && (exec_circle->OwnerScreen == CurrentScreen)) {
          DrawCircle(exec_circle);
        }
        break;
      }
      break;
    }
    // Box
    case 6: {
      if (PressedObject != 0) {
        exec_box = (TBox*)PressedObject;
        if ((exec_box->PressColEnabled != 0) && (exec_box->OwnerScreen == CurrentScreen)) {
          DrawBox(exec_box);
        }
        break;
      }
      break;
    }
  }

  exec_label          = 0;
  exec_image          = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
  // Buttons
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->OnUpPtr != 0)
          exec_button->OnUpPtr();
        if (PressedObject == (void *)exec_button)
          if (exec_button->OnClickPtr != 0)
            exec_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnUpPtr != 0)
          exec_label->OnUpPtr();
        if (PressedObject == (void *)exec_label)
          if (exec_label->OnClickPtr != 0)
            exec_label->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Images
    if (_object_count == image_order) {
      if (exec_image->Active != 0) {
        if (exec_image->OnUpPtr != 0)
          exec_image->OnUpPtr();
        if (PressedObject == (void *)exec_image)
          if (exec_image->OnClickPtr != 0)
            exec_image->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Circles
    if (_object_count == circle_order) {
      if (exec_circle->Active != 0) {
        if (exec_circle->OnUpPtr != 0)
          exec_circle->OnUpPtr();
        if (PressedObject == (void *)exec_circle)
          if (exec_circle->OnClickPtr != 0)
            exec_circle->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Boxes
    if (_object_count == box_order) {
      if (exec_box->Active != 0) {
        if (exec_box->OnUpPtr != 0)
          exec_box->OnUpPtr();
        if (PressedObject == (void *)exec_box)
          if (exec_box->OnClickPtr != 0)
            exec_box->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_button         = 0;
  exec_label          = 0;
  exec_image          = 0;
  exec_circle         = 0;
  exec_box            = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->PressColEnabled != 0) {
          object_pressed = 1;
          DrawButton(exec_button);
        }
        PressedObject = (void *)exec_button;
        PressedObjectType = 0;
        if (exec_button->OnDownPtr != 0) {
          exec_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        PressedObject = (void *)exec_label;
        PressedObjectType = 2;
        if (exec_label->OnDownPtr != 0) {
          exec_label->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == image_order) {
      if (exec_image->Active != 0) {
        PressedObject = (void *)exec_image;
        PressedObjectType = 3;
        if (exec_image->OnDownPtr != 0) {
          exec_image->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == circle_order) {
      if (exec_circle->Active != 0) {
        if (exec_circle->PressColEnabled != 0) {
          object_pressed = 1;
          DrawCircle(exec_circle);
        }
        PressedObject = (void *)exec_circle;
        PressedObjectType = 4;
        if (exec_circle->OnDownPtr != 0) {
          exec_circle->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active != 0) {
        if (exec_box->PressColEnabled != 0) {
          object_pressed = 1;
          DrawBox(exec_box);
        }
        PressedObject = (void *)exec_box;
        PressedObjectType = 6;
        if (exec_box->OnDownPtr != 0) {
          exec_box->OnDownPtr();
          return;
        }
      }
    }

  }
}

void Check_TP() {
  if (STMPE610_PressDetect()) {
    if (STMPE610_GetLastCoordinates(&Xcoord, &Ycoord) == 0) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
      Process_TP_Press(Xcoord, Ycoord);
      if (PenDown == 0) {
        PenDown = 1;
        Process_TP_Down(Xcoord, Ycoord);
      }
    }
  }
  else if (PenDown == 1) {
    PenDown = 0;
    Process_TP_Up(Xcoord, Ycoord);
  }
}

void Init_MCU() {
char _cnt;
  GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_6);
  for (_cnt = 0; _cnt < 20; _cnt++) {
    GPIOB_ODR.B6 = 0;
    Delay_ms(1);
    GPIOB_ODR.B6 = 1;
    Delay_ms(1);
  }

  I2C1_Init_Advanced(400000, &_GPIO_MODULE_I2C1_PB67);
  TFT_Set_Default_Mode();
  GPIO_Digital_Output(&GPIOG_BASE, 0x00FF);
  GPIO_Digital_Output(&GPIOE_BASE, 0xFF00);
  GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_4);
  GPIOB_ODR.B4 = 0;
  TFT_Set_Default_Mode();
  TFT_Set_MM_Plus();
  STMPE610_SetDefaultMode();
}

char STMPE610_Config()  {
  STMPE610_SetI2CAddress(STMPE610_I2C_ADDR1);
  if (STMPE610_IsOperational() != 0){
    return STMPE610_IO_NOT_OPERATIONAL;
  }

  STMPE610_Reset();
  STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
  STMPE610_AlternateFunction(STMPE610_GPIO_PIN1, STMPE610_ENABLE);
  STMPE610_SetGPIOPin(STMPE610_GPIO_PIN1, 0);   // IN1 to "0" -> I2C communication
  STMPE610_SetSize(480,272);
  STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
  STMPE610_EnableInterrupt(STMPE610_IE_TOUCH_DET | STMPE610_IE_FIFO_TH | STMPE610_IE_FIFO_0FLOW, STMPE610_ENABLE);
  STMPE610_ConfigureInterrupt(STMPE610_INT_POLARITY_ACTIVE_HIGH | STMPE610_INT_TYPE_EDGE | STMPE610_INT_ENABLE_ALL);
  STMPE610_SetADC(STMPE610_ADC_CTRL1_SAMPLETIME_44 | STMPE610_ADC_CTRL1_ADC_10BIT | STMPE610_ADC_CTRL1_INT_REFERENCE);
  Delay_10ms(); Delay_10ms();
  STMPE610_SetADCClock(STMPE610_ADC_CTRL2_6500_kHZ);
  STMPE610_AlternateFunction(STMPE610_GPIO_PIN4 | STMPE610_GPIO_PIN5 | STMPE610_GPIO_PIN6 | STMPE610_GPIO_PIN7, STMPE610_DISABLE);
  STMPE610_ConfigureTSC(STMPE610_TSC_CFG_AVE_CTRL_8S, STMPE610_TSC_CFG_TOUCH_DET_DELAY_500uS, STMPE610_TSC_CFG_TOUCH_SETTLING_500uS);
  STMPE610_SetFIFOThreshold(1);
  STMPE610_ResetFIFO();
  STMPE610_TSIDrive(STMPE610_TSC_I_DRIVE_20mA);
  STMPE610_TSControl(STMPE610_TSC_CTRL_TRACK0 | STMPE610_TSC_CTRL_ACQU_XYZ | STMPE610_TSC_CTRL_ENABLE);
  STMPE610_ZDataFraction(STMPE610_FRACP4_WHOLP4);
  STMPE610_SetTouchPressureThreshold(70);
  STMPE610_ClearInterrupts();
  STMPE610_WriteReg(STMPE610_INT_CTRL_REG, 0x01);
  return STMPE610_OK;
}


void Start_TP() {
TTPConstants TPConstsStruct;
  Init_MCU();

  InitializeTouchPanel();
  if (STMPE610_Config() == STMPE610_OK) {
  } else {
    while(1);
  }


  // You can get calibration constants using touch panel calibration example
  TPConstsStruct.X_Min = 105;
  TPConstsStruct.X_Max = 3925;
  TPConstsStruct.Y_Min = 250;
  TPConstsStruct.Y_Max = 3820;
  TPConstsStruct.Rotate = 0;
  STMPE610_SetCalibrationConsts(&TPConstsStruct);

  InitializeObjects();
  display_width = home.Width;
  display_height = home.Height;
  DrawScreen(&home);
}