/*******************************************************************************
***        module: mmp_leddemo_helpers.c
***            by: Jack Eberson
***      compiler: MikroC PRO for ARM V6.0.0
***      hardware: Mikromedia plus with STM32F746ZG and shield
***   description: (display) helper routines
*******************************************************************************/

#include "mmp_leddemo_objects.h"
#include "mmp_leddemo_resources.h"
#include "types.h"

// Draw the led in the display.
void hlpShowLed(TCircle *ACircle)
{
   DrawCircle(ACircle);
}

// Draw a text Label in the display
void hlpShowLabel(TLabel *ALabel)
{
   DrawLabel(ALabel) ;
}

// RED led in display ON
void hlpRedLedOn ()
{
  LedRedIndicator.Visible              = 1;
  LedRedIndicator.Active               = 1;
  LedRedIndicator.Transparent          = 1;
  LedRedIndicator.Gradient             = 0;
  //LedRedIndicator.Gradient_Start_Color = CL_RED;
  //LedRedIndicator.Gradient_End_Color   = 0xC618;
  LedRedIndicator.Color                = CL_RED;
  LedRedIndicator.Press_Color          = home.Color;
  hlpShowLed(&LedRedIndicator);
}

// RED led in display OFF
void hlpRedLedOff ()
{
  LedRedIndicator.Visible              = 1;
  LedRedIndicator.Active               = 1;
  LedRedIndicator.Transparent          = 1;
  LedRedIndicator.Gradient             = 0;
  //LedRedIndicator.Gradient_Start_Color = home.Color;
  //LedRedIndicator.Gradient_End_Color   = home.Color;
  LedRedIndicator.Color                = home.Color;
  LedRedIndicator.Press_Color          = home.Color;
  hlpShowLed(&LedRedIndicator);
}

// GREEN led in display ON
void hlpGreenLedOn ()
{
  LedGreenIndicator.Visible              = 1;
  LedGreenIndicator.Active               = 1;
  LedGreenIndicator.Transparent          = 1;
  LedGreenIndicator.Gradient             = 0;
  //LedGreenIndicator.Gradient_Start_Color = CL_GREEN;
  //LedGreenIndicator.Gradient_End_Color   = 0xC618;
  LedGreenIndicator.Color                = CL_GREEN;
  LedGreenIndicator.Press_Color          = home.Color;
  hlpShowLed(&LedGreenIndicator);
}

// GREEN led in display OFF
void hlpGreenLedOff ()
{
  LedGreenIndicator.Visible              = 1;
  LedGreenIndicator.Active               = 1;
  LedGreenIndicator.Transparent          = 1;
  LedGreenIndicator.Gradient             = 0;
  //LedGreenIndicator.Gradient_Start_Color = home.Color;
  //LedGreenIndicator.Gradient_End_Color   = home.Color;
  LedGreenIndicator.Color                = home.Color;
  LedGreenIndicator.Press_Color          = home.Color;
  hlpShowLed(&LedGreenIndicator);
}

// BLUE led in display ON
void hlpBlueLedOn ()
{
  LedBlueIndicator.Visible              = 1;
  LedBlueIndicator.Active               = 1;
  LedBlueIndicator.Transparent          = 1;
  LedBlueIndicator.Gradient             = 0;
  //LedBlueIndicator.Gradient_Start_Color = CL_BLUE;
  //LedBlueIndicator.Gradient_End_Color   = 0xC618;
  LedBlueIndicator.Color                = CL_BLUE;
  LedBlueIndicator.Press_Color          = home.Color;
  hlpShowLed(&LedBlueIndicator);
}

// BLUE led in display OFF
void hlpBlueLedOff ()
{
  LedBlueIndicator.Visible              = 1;
  LedBlueIndicator.Active               = 1;
  LedBlueIndicator.Transparent          = 1;
  LedBlueIndicator.Gradient             = 0;
  //LedBlueIndicator.Gradient_Start_Color = home.Color;
  //LedBlueIndicator.Gradient_End_Color   = home.Color;
  LedBlueIndicator.Color                = home.Color;
  LedBlueIndicator.Press_Color          = home.Color;
  hlpShowLed(&LedBlueIndicator);
}

// CAN TX led in display ON
void hlpCAN_TxIndicatorOn ()
{
  CANTXIndicator.Visible              = 1;
  CANTXIndicator.Active               = 1;
  CANTXIndicator.Transparent          = 1;
  CANTXIndicator.Gradient             = 0;
  //CANTXIndicator.Gradient_Start_Color = CL_YELLOW;
  //CANTXIndicator.Gradient_End_Color   = 0xC618;
  CANTXIndicator.Color                = CL_YELLOW;
  CANTXIndicator.Press_Color          = home.Color;
  hlpShowLed(&CANTXIndicator);
}

// CAN TX led in display OFF
void hlpCAN_TxIndicatorOFF ()
{
  CANTXIndicator.Visible              = 1;
  CANTXIndicator.Active               = 1;
  CANTXIndicator.Transparent          = 1;
  CANTXIndicator.Gradient             = 0;
  //CANTXIndicator.Gradient_Start_Color = Box1.Gradient_End_Color;
  //CANTXIndicator.Gradient_End_Color   = Box1.Gradient_End_Color;
  CANTXIndicator.Color                = Box1.Gradient_End_Color;
  CANTXIndicator.Press_Color          = Box1.Gradient_End_Color;
  hlpShowLed(&CANTXIndicator);
}

// CAN RX led in display ON
void hlpCAN_RxIndicatorOn ()
{
  CANRXIndicator.Visible              = 1;
  CANRXIndicator.Active               = 1;
  CANRXIndicator.Transparent          = 1;
  CANRXIndicator.Gradient             = 0;
  //CANRXIndicator.Gradient_Start_Color = CL_YELLOW;
  //CANRXIndicator.Gradient_End_Color   = 0xC618;
  CANRXIndicator.Color                = CL_YELLOW;
  CANRXIndicator.Press_Color          = home.Color;
  hlpShowLed(&CANRXIndicator);
}

// CAN RX led in display OFF
void hlpCAN_RxIndicatorOFF ()
{
  CANRXIndicator.Visible              = 1;
  CANRXIndicator.Active               = 1;
  CANRXIndicator.Transparent          = 1;
  CANRXIndicator.Gradient             = 0;
  //CANRXIndicator.Gradient_Start_Color = Box1.Gradient_End_Color;
  //CANRXIndicator.Gradient_End_Color   = Box1.Gradient_End_Color;
  CANRXIndicator.Color                = Box1.Gradient_End_Color;
  CANRXIndicator.Press_Color          = Box1.Gradient_End_Color;
  hlpShowLed(&CANRXIndicator);
}

// Write received ID in the display
void hlpCAN_WriteID(uint32_t ID)
{
  uint8_t tmpBuffer[20];

  LongWordToHex(ID,tmpBuffer);
  rcvdID.Visible         = 1;
  rcvdID.Active          = 1;
  rcvdID.Caption         = tmpBuffer;
  rcvdID.FontName        = Tahoma11x13_Regular;
  rcvdID.Font_Color      = 0x0010;
  rcvdID.VerticalText    = 0;
  hlpShowLabel(&rcvdID);
}

// Write received DLC in the display
void hlpCAN_WriteDLC(uint8_t DLC)
{
  uint8_t tmpBuffer[10];

  ByteToHex(DLC,tmpBuffer);
  rcvdDLC.Visible         = 1;
  rcvdDLC.Active          = 1;
  rcvdDLC.Caption         = tmpBuffer;
  rcvdDLC.FontName        = Tahoma11x13_Regular;
  rcvdDLC.Font_Color      = 0x0010;
  rcvdDLC.VerticalText    = 0;
  hlpShowLabel(&rcvdDLC);
}

// Write received DATA in the display
// Non valid bytes are display as "--".
void hlpCAN_WriteDATA(uint8_t DLC, uint8_t *DATA)
{
  uint8_t tmpBuffer[20];
  uint8_t i;
  TLabel *DataByte;

  for (i=0;i<DLC;++i)
  {
     ByteToHex(DATA[i], tmpBuffer);
     switch (i)
     {
       case 1 : DataByte = &rcvdDB1; break;
       case 2 : DataByte = &rcvdDB2; break;
       case 3 : DataByte = &rcvdDB3; break;
       case 4 : DataByte = &rcvdDB4; break;
       case 5 : DataByte = &rcvdDB5; break;
       case 6 : DataByte = &rcvdDB6; break;
       case 7 : DataByte = &rcvdDB7; break;
       default: DataByte = &rcvdDB0;
     }

     DataByte->Visible         = 1;
     DataByte->Active          = 1;
     DataByte->Caption         = tmpBuffer;
     DataByte->FontName        = Tahoma11x13_Regular;
     DataByte->Font_Color      = 0x0010;
     DataByte->VerticalText    = 0;
     hlpShowLabel(DataByte);
  }

  for (i=DLC;i<8;++i)
  {
     switch (i)
     {
       case 1 : DataByte = &rcvdDB1; break;
       case 2 : DataByte = &rcvdDB2; break;
       case 3 : DataByte = &rcvdDB3; break;
       case 4 : DataByte = &rcvdDB4; break;
       case 5 : DataByte = &rcvdDB5; break;
       case 6 : DataByte = &rcvdDB6; break;
       case 7 : DataByte = &rcvdDB7; break;
       default: DataByte = &rcvdDB0;
     }
     
     DataByte->Visible         = 1;
     DataByte->Active          = 1;
     DataByte->Caption         = "--";
     DataByte->FontName        = Tahoma11x13_Regular;
     DataByte->Font_Color      = 0x0010;
     DataByte->VerticalText    = 0;
     hlpShowLabel(DataByte);
  }
}

// Update the received CAN data in the display
void hlpDisplayReceivedCAN_Data(uint32_t ID, uint8_t DLC, uint8_t *Data)
{
  DrawBox(&dynamicbox_1);  // <-- clears the previous text
  hlpCAN_WriteID(ID);
  hlpCAN_WriteDLC(DLC);
  hlpCAN_WriteDATA(DLC, Data);
}
